//-*-c++-*-
#uses "fwUkl1.ctl"

//This script will run once, finding any CCPCs boards that are in the system and ensuring that the datapoints have been setup.
//This includes the FSM tree and the CCPC/DIM server connections and data points.
main()
{
  //First we will delay for 2secs to ensure that the CCPCs have been found by DIM.
  //delay(2);//no we won't.
  //Now call the appropriate fwUkl1.ctl lib function that fill find and add all the boards that we may desire.
  //We can assume that any settings that were present from a previous run should still be valid.
  const bool refresh = TRUE;
  //We are happy to use the current default settings on the system.
  const bool forceReconfigure = FALSE;
  //Don't recreate any data points that may already be there, just update them to initialise values.
  const bool deleteExisting = FALSE;
  dyn_string exceptionInfo;
  fwUkl1_findAndAddUkl1Boards(refresh, deleteExisting, forceReconfigure, exceptionInfo);
  //Check to ensure that the FSM has been started. Get the state of the CU.
  string ukl1CUstate;
  fwCU_getState(FWUKL1_CU, ukl1CUstate);
  if ( "DEAD" == ukl1CUstate) {
    DebugTN("FSM found not to be started. Starting FSM.");
    //Start the FSM tree node and accept the default argument of recursing down the tree.
    //Don't worry about regenerating the FSM as it won't have changed since last time.
    //Also the CU and DEN don't need to be refreshed as it will only change the state of the FSM.
    fwFsmTree_generateTreeNode(FWUKL1_CU);
    fwFsmTree_startTreeNode(FWUKL1_CU);
  } else {
    DebugTN("FSM found to be running.");
  }
  DebugTN("Found boards");
  return;
}
